﻿using Newtonsoft.Json.Linq;
using PTMedicalInsurance.Helper;
using PTMedicalInsurance.Variables;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Business
{
    class RealNameAuthentication
    {
        private InvokeHelper invoker = new InvokeHelper();
        public JObject CallFaceOfOutpat()
        {
            JObject joIn = new JObject();
            joIn.Add("id", Global.pat.certNO);
            joIn.Add("psn", Global.pat.psn_no);
            joIn.Add("name", Global.pat.name);
            joIn.Add("deal_no", Global.pat.adm_Dr);
            joIn.Add("mdtrtarea_admvs", Global.inf.areaCode);
            joIn.Add("insuplc_admdvs", Global.pat.insuplc_admdvs);
            joIn.Add("infver", "V1.0");
            joIn.Add("opter_type", Global.user.type);
            joIn.Add("opter", Global.user.ID);
            joIn.Add("opter_name", Global.user.name);
            joIn.Add("fixmedins_code", Global.inf.hospitalNO);
            joIn.Add("fixmedins_name", Global.inf.hospitalName);
            joIn.Add("mdtrt_cert_type", Global.pat.mdtrtcertType);
            joIn.Add("begntime", Global.settl.hisAdmTime);
            joIn.Add("medfee_sumamt","0");
            joIn.Add("invono", "");
            joIn.Add("insutype", Global.pat.insuType);
            joIn.Add("dise_codg", Global.pat.discDiagCode);
            joIn.Add("dise_name", Global.pat.discDiagName);
            joIn.Add("acct_used_flag", Global.pat.personAccountUsedFlag);
            joIn.Add("med_type", Global.pat.medType);
            joIn.Add("fulamt_ownpay_amt", "0.0");
            joIn.Add("overlmt_selfpay", "0.0");
            joIn.Add("preselfpay_amt", "0.0");
            joIn.Add("inscp_scp_amt", "0.0");
            joIn.Add("exp_content", "");


            JObject joRtn = invoker.invokeRealNameService(joIn.ToString());
            return joRtn;
        }

        public JObject DoctorAttendance(JObject jo)
        {
            string outParam;
            HisCallFace hcf = new HisCallFace();
            hcf.HisCallAtten(jo.ToString(), out outParam);
            JObject joRtn = JObject.Parse(outParam);
            Global.writeLog(joRtn.ToString());
            return joRtn;
        }

        public JObject CallFace(JObject jo)
        {
            string outParam;
            HisCallFace hcf = new HisCallFace();
            hcf.zjHisFunCall(jo.ToString(), out outParam);
            JObject joRtn = JObject.Parse(outParam);
            Global.writeLog(joRtn.ToString());
            return joRtn;
        }
    }
}
