﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Security.Cryptography;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using PTMedicalInsurance.Variables;
using SM2Crypto.Lib;

namespace PTMedicalInsurance.Common
{
    class Encrypt
    {
        public static string ToBase64hmac(string strText, string strKey)

        {

            HMACSHA1 myHMACSHA1 = new HMACSHA1(Encoding.UTF8.GetBytes(strKey));

            byte[] byteText = myHMACSHA1.ComputeHash(Encoding.UTF8.GetBytes(strText));

            return System.Convert.ToBase64String(byteText);

        }

        public static string HMACSHA1Text(string EncryptText, string EncryptKey)
        {
            //HMACSHA1加密
            string message;
            string key;
            message = EncryptText;
            key = EncryptKey;

            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            byte[] keyByte = encoding.GetBytes(key);
            HMACSHA1 hmacsha1 = new HMACSHA1(keyByte);
            byte[] messageBytes = encoding.GetBytes(message);
            byte[] hashmessage = hmacsha1.ComputeHash(messageBytes);

            //return ByteToString(hashmessage);
            return Convert.ToBase64String(hashmessage);
        }

        public static string HMACSHA1Text2(string EncryptText, string EncryptKey)

        {
            //HMACSHA1加密
            HMACSHA1 hmacsha1 = new HMACSHA1();
            hmacsha1.Key = System.Text.Encoding.UTF8.GetBytes(EncryptKey);

            byte[] dataBuffer = System.Text.Encoding.UTF8.GetBytes(EncryptText);
            byte[] hashBytes = hmacsha1.ComputeHash(dataBuffer);
            return Convert.ToBase64String(hashBytes);
        }
    }

    class HaErBinEncrypt
    {


        //const string sm2key = "AYvxpsjPGd06aErh6w8uMFKqXwpV6V0pXJYuP4KfD0s=";
        //const string sm4key = "RNSNupzo1RAizTKU";

         string sm2key =Global.inf.sm2key;
         string sm4key = Global.inf.sm4key;

        public string Signature(string plain)
        {
            string signature = "";
            try
            {
                signature = SMUtil.sign(plain, sm2key);
                return signature;
            }
            catch (Exception ex)
            {
                return "签名异常：" + ex.Message;
            }
        }



        public string Encrypt(string plain)
        {
            try
            {

                string encryptData = SMUtil.encrypt(plain, sm4key);
                Global.writeLog_encrypt("Encrypt_encryptData:" + encryptData);
                //int a = PcharDispose();
                //Global.writeLog_encrypt("Decrypt_PcharDispose:" + a.ToString());
                return encryptData;
            }
            catch (Exception ex)
            {
                Global.writeLog_encrypt("加密异常" + ex.Message);
                return "加密异常：" + ex.Message;
            }
        }

        public string Decrypt(string cipher)
        {
            if (string.IsNullOrEmpty(cipher))
            {
                MessageBox.Show("密文传入为空");
                return "";
            }

            try
            {
                string decryptData = SMUtil.decrypt(cipher, sm4key); ;
                Global.writeLog_encrypt("Decrypt_cipher:" + cipher);
                return decryptData;
            }
            catch (Exception ex)
            {
                Global.writeLog_encrypt("解密异常" + ex.Message);
                return "解密异常：" + ex.Message;
            }
        }

        public static string EncryptBySM3HASH(string plain)
        {
            try
            {
                string decryptData = SMUtil.EncryptBySM3HASH(plain); ;
                return decryptData;
            }
            catch (Exception ex)
            {
                Global.writeLog_encrypt("SM3加密异常：" + ex.Message);
                return "SM3加密异常：" + ex.Message;
            }
        }
    }
}
