﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PTMedicalInsurance.Common;
using PTMedicalInsurance.Helper;
using Newtonsoft.Json.Linq;
using PTMedicalInsurance.FormSetter;
using System.IO;
using System.IO.Compression;
using PTMedicalInsurance.Business;
using Sunny.UI;
using Newtonsoft.Json;
using System.Collections;
using PTMedicalInsurance.Variables;

namespace PTMedicalInsurance.Forms
{
    public partial class Clearing : Form
    {
        private string txtPath;
        private string txtName;
        private string finalAchPath;
        private UIDataGridViewFooter dgvHisSettlRecFooter = new Sunny.UI.UIDataGridViewFooter();
        JObject jo9102Rtn = new JObject();
        GridViewSetter grdSetter = new GridViewSetter();

        public Clearing()
        {
            InitializeComponent();
        }

        private void Clearing_Load(object sender, EventArgs e)
        {
            ComboxSetter cbxSetter = new ComboxSetter();
            cbxSetter.setCbxInterfaceDataSource(cbxInterface);
            cbxSetter.setCbxInterfaceDataSource(cbxInterface_2);
            cbxSetter.setCbxDictionaryDataSource(Global.inf.interfaceDr.ToString(), "insutype", cbxInsuType);
            cbxSetter.setCbxDictionaryDataSource(Global.inf.interfaceDr.ToString(), "clr_type", cbxClrType);


            cbxInterface.SelectedValueChanged += new EventHandler(cbxInterface_SelectedValueChanged);
            cbxInterface_2.SelectedValueChanged += new EventHandler(cbxInterface_2_SelectedIndexChanged);

            
            grdSetter.SetHeaderTextOfCheck(dgvSettlSummary);
            grdSetter.SetHeaderTextOfDgvCenterSetlRec(dgvCenterSettlRec);
            grdSetter.SetHeaderTextOfCenterMonthSettlData(dgvCenterMonthSettlData);

            cbgGroupSet.SelectAll();
            cbgGroupSet.SetItemCheckState(0, false);
            cbgGroupSet.SetItemCheckState(3, false);
            cbgGroupSet.SetItemCheckState(4, false);
            cbxValid.SelectedIndex = 0;
            cbxOtherPlcFlag.SelectedIndex = 0;


            dpST.Text = DateTime.Now.ToString("yyyy-MM-01 00:00:00");
            dpMonth.Text = DateTime.Now.ToString("yyyy-MM-01");
            DateTime dt = DateTime.Now.AddDays(1 - DateTime.Now.Day).AddMonths(1).AddDays(-1);
            dpED.Text = dt.ToString("yyyy-MM-dd ") + ("23:59:59");
            dpED.Text = DateTime.Now.ToString("yyyy-MM-01 23:59:59");

            WindowState = FormWindowState.Maximized;

            tbTmp.Text= Global.curEvt.path + "\\Download";
        }

        private void cbxInterface_SelectedValueChanged(object sender, EventArgs e)
        {
            DataTable dtInteface = (DataTable)cbxInterface.DataSource;
            int i = cbxInterface.SelectedIndex;
            if (i != 2)
            {
                Global.pat.insuplc_admdvs = "";
            }
            else
            {
                Global.pat.insuplc_admdvs = "530199";
            }
            Global.inf.hospitalNO = dtInteface.Rows[i]["HospitalNO"].ToString();
            Global.inf.hospitalName = dtInteface.Rows[i]["HospitalName"].ToString();
            Global.inf.centerURL = dtInteface.Rows[i]["CenterURL"].ToString();
            Global.inf.areaCode = dtInteface.Rows[i]["AreaCode"].ToString();
            Global.user.name = "0";
            Global.user.ID = "0";
            //Global.inf.operatorType = "3";
            Global.inf.version = "v1.0";
            Global.inf.recivedSystem = "SY";
            Global.inf.interfaceDr = int.Parse(dtInteface.Rows[i]["ID"].ToString());

            ComboxSetter cbxSetter = new ComboxSetter();
            cbxSetter.setCbxDictionaryDataSource(dtInteface.Rows[i]["ID"].ToString(), "insutype", cbxInsuType);
            cbxSetter.setCbxDictionaryDataSource(dtInteface.Rows[i]["ID"].ToString(), "clr_type", cbxClrType);
        }

        


        /// <summary>
        /// 单条对总账事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tsmCheck_Single_Click(object sender, EventArgs e)
        {
            string error = "";
            if (Check_Single(out error) != 0)
            {
                MessageBox.Show("对总账失败：" + error);
            }
            else
            {
                MessageBox.Show("对总账成功");
            }

        }

        /// <summary>
        /// 单条对总账【本地】
        /// </summary>
        /// <param name="error"></param>
        /// <returns></returns>
        private int Check_Single(out string error)
        {
            error = "";
            DataTable dt = (DataTable)dgvSettlSummary.DataSource;
            int i = dgvSettlSummary.CurrentRow.Index;

            dynamic joCheck = new JObject();
            joCheck.insutype = dt.Rows[i]["insutype"].ToString();                       //险种类型
            joCheck.clr_type = dt.Rows[i]["clr_type"].ToString();                       //清算类别
            string setlOptins = dt.Rows[i]["setl_optins"].ToString();
            if (cbxOtherPlcFlag.SelectedIndex == 1)
            {
                setlOptins = "239900";
            }
            else
            {
                setlOptins = "230199";
            }
            joCheck.setl_optins = setlOptins;                //结算经办机构
            Decimal fund_pay_sumamt = Decimal.Parse(dt.Rows[i]["fund_pay_sumamt"].ToString());
            Decimal acct_pay = Decimal.Parse(dt.Rows[i]["acct_pay"].ToString());
            if (cbxOtherPlcFlag.SelectedIndex == 1)
            {
                fund_pay_sumamt = fund_pay_sumamt + acct_pay;
            }
            joCheck.medfee_sumamt = dt.Rows[i]["medfee_sumamt"].ToString();             //医疗费总额
            joCheck.fund_pay_sumamt = fund_pay_sumamt.ToString();         //基金支付总额
            joCheck.acct_pay = dt.Rows[i]["acct_pay"].ToString();                       //个人账户支付金额
            joCheck.fixmedins_setl_cnt = dt.Rows[i]["fixmedins_setl_cnt"].ToString();   //定点医药机构结算笔数
            joCheck.stmt_begndate = dpST.Value.ToString("yyyy-MM-dd");         //对账开始日期
            joCheck.stmt_enddate = dpED.Value.ToString("yyyy-MM-dd");          //对账结束日期

            JObject joData = new JObject();
            joData.Add("data", joCheck);
            //是否需要？
            if (tbSettlOption.Text != "")
            {
                Global.pat.insuplc_admdvs = tbSettlOption.Text;
            }
            //上传给中心
            string funNO = "3201";
            Global.inf.areaCode = "230100";
            Global.pat.insuplc_admdvs = "";
            if (cbxOtherPlcFlag.SelectedIndex == 1)
            {
                funNO = "3260";
                Global.inf.areaCode = "239900";
                Global.pat.insuplc_admdvs = "";
            }
            
            InvokeHelper invoker = new InvokeHelper();
            JObject joRtn = invoker.invokeCenterService(funNO,  joData); 
            if (JsonHelper.parseCenterRtnValue(joRtn, out error) != 0)
            {
                return -1;
            }
            else
            {
                if (JsonHelper.getDestValue(joRtn, "output.stmtinfo.stmt_rslt") != "0")
                {
                    error = JsonHelper.getDestValue(joRtn, "output.stmtinfo.stmt_rslt_dscr");
                    return -1;
                }
                else
                {
                    return 0;
                }
            }
        }

        

        private int queryHisSettlementInfo(out string error)
        {
            GridViewSetter grdSetter = new GridViewSetter();
            grdSetter.SetHeaderTextOfHisSettlRec(dgvHisSettlRec);
            error = "";
            try
            {
                string sqlStr = "";
                string conditionStr = " ";
                DataTable dtSettlSummary = (DataTable)dgvSettlSummary.DataSource;
                int iCurRow = dgvSettlSummary.CurrentRow.Index;

                //DataTable dtInteface = (DataTable)cbxInterface.DataSource;
                if (!string.IsNullOrEmpty(dtSettlSummary.Rows[iCurRow]["Interface_dr"].ToString()))
                {
                    conditionStr = conditionStr + " and Interface_Dr ='" + dtSettlSummary.Rows[iCurRow]["Interface_dr"].ToString() + "'";
                }
                if (!string.IsNullOrEmpty(dtSettlSummary.Rows[iCurRow]["insutype"].ToString()))
                {
                    conditionStr = conditionStr + " and InsuranceType ='" + dtSettlSummary.Rows[iCurRow]["insutype"].ToString() + "'";
                }
                if (!string.IsNullOrEmpty(dtSettlSummary.Rows[iCurRow]["clr_type"].ToString()))
                {
                    conditionStr = conditionStr + " and ClearingType ='" + dtSettlSummary.Rows[iCurRow]["clr_type"].ToString() + "'";
                }
                if (!string.IsNullOrEmpty(dtSettlSummary.Rows[iCurRow]["setl_optins"].ToString()))
                {
                    conditionStr = conditionStr + " and ClearingOrgan ='" + dtSettlSummary.Rows[iCurRow]["setl_optins"].ToString() + "'";
                }
  

                //if (!string.IsNullOrEmpty(dtSettlSummary.Rows[iCurRow]["BillType"].ToString()))
                //{
                //    sqlStr = sqlStr + ",BillType";
                //    conditionStr = conditionStr + " and BillType ='" + dtSettlSummary.Rows[iCurRow]["BillType"].ToString() + "'";
                //}
                
                sqlStr = "select *  FROM  BS_MedInsuSettlement WHERE Hospital_Dr=" + Global.inf.hospitalDr;
                sqlStr = sqlStr + " and OccurTime>'" + dpST.Text + "'";
                sqlStr = sqlStr + " and OccurTime<'" + dpED.Text + "'";

                //ValidFlag=1 and BillType=1 表示正常结算记录   ValidFlag=0 and BillType=-1 表示退费记录  ValidFlag=0表示无效记录 
                if (cbxValid.SelectedIndex != 0)
                {
                    if (cbxValid.SelectedIndex == 1)
                        sqlStr = sqlStr + " and ValidFlag =1 and BillType=1";
                    else
                        sqlStr = sqlStr + " and ValidFlag =0 and BillType=-1";
                }

                //省医保和市医保对账一样，异地对账需要用到另外的对账交易
                sqlStr = sqlStr + " and ReversalFlag <> 1 ";

                if (cbxOtherPlcFlag.SelectedIndex == 1)
                    sqlStr = sqlStr + " and (InsuranceAreaCode<>'239900' and SUBSTRING(InsuranceAreaCode,1,4)<>'2301' and SUBSTRING(InsuranceAreaCode,1,4)<>'2331')";
                else if (cbxOtherPlcFlag.SelectedIndex == 0)
                    sqlStr = sqlStr + " and (InsuranceAreaCode='239900' or SUBSTRING(InsuranceAreaCode,1,4) in ('2301','2331'))";
                //铁路医保参保地为233100 这里对账的时候需要包含进去

                //conditionStr = conditionStr.Substring(0,conditionStr.Length -1 );
                //conditionStr = conditionStr.Remove(conditionStr.Length - 1, 1);

                sqlStr = sqlStr + conditionStr;
                JObject joSqlstr = new JObject();
                joSqlstr.Add("sqlStr", sqlStr);
                JArray jaParam = new JArray();
                jaParam.Add(joSqlstr);
                JObject joSettlQuery = new JObject();
                joSettlQuery.Add("params", jaParam);
                joSettlQuery.Add("code", "09010059");
                InvokeHelper invoker = new InvokeHelper();
                JObject joRtn = invoker.invokeInsuService(joSettlQuery.ToString(), "查询结算信息");

                //DataTable dt = (DataTable)joRtn["result"]["data"].ToObject(typeof(DataTable));
                JArray ja = JArray.Parse(JsonHelper.getDestValue(joRtn, "result.data"));
                DataTable dt = (DataTable)JsonConvert.DeserializeObject(JsonHelper.getDestValue(joRtn, "result.data"), (typeof(DataTable)));
                dgvHisSettlRec.DataSource = dt;
                //dt.Columns[7].DataType = typeof(float);//不允许
                //dgvHisSettlRecFooter.DataGridView = dgvHisSettlRec;
                //dgvHisSettlRecFooter.Dock = System.Windows.Forms.DockStyle.Bottom;
                //dgvHisSettlRecFooter.Clear();
                //dgvHisSettlRecFooter["AdmID"] = "合计";
                //dgvHisSettlRecFooter["OverLimitAmount"] = "测试";

                return 0;
            }
            catch (Exception ex)
            {
                error = "queryHisSettlementInfo:" + ex.Message;
                return -1;
            }
        }

        private void tsmCheckDetail_Single_Click(object sender, EventArgs e)
        {
            //HIS明细
            string error;
            if (queryHisSettlementInfo(out error) != 0)
            {
                MessageBox.Show(error);
            }
            //中心明细
            if (CheckDetail_Single(out error) != 0)
            {
                MessageBox.Show(error);
            }
        }

        /// <summary>
        /// 查询HIS结算明细记录
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tsmHisRecord_Click(object sender, EventArgs e)
        {
            string error;
            if (queryHisSettlementInfo(out error) != 0)
            {
                MessageBox.Show(error);
            }
        }

        public static void writeToTxt(string content, string filePath, string fileName)
        {
            //创建文件夹,文件夹名称与TXT同名
            string finalPath = filePath + "\\" + fileName;
            if (!Directory.Exists(finalPath))
            {
                DirectoryInfo dirInfo = Directory.CreateDirectory(finalPath);
            }
            //判断文件夹中是否存在txt
            string finalFileName = finalPath + "\\" + fileName + ".txt";
            if (!File.Exists(finalFileName))
            {
                FileStream fs1 = File.Create(finalFileName);
                fs1.Close();
            }

            FileStream fs = new FileStream(finalFileName, FileMode.Append, FileAccess.Write);
            StreamWriter sw = new StreamWriter(fs);
            sw.WriteLine(content);
            sw.Close();
            fs.Close();
        }

        /// <summary>
        /// 读文件到byte[]
        /// </summary>
        /// <param name="fileName">硬盘文件路径</param>
        /// <returns></returns>
        public static byte[] ReadFileToByte(string fileName)
        {
            FileStream pFileStream = null;
            byte[] pReadByte = new byte[0];
            try
            {
                pFileStream = new FileStream(fileName, FileMode.Open, FileAccess.Read);
                BinaryReader r = new BinaryReader(pFileStream);
                r.BaseStream.Seek(0, SeekOrigin.Begin);    //将文件指针设置到文件开
                pReadByte = r.ReadBytes((int)r.BaseStream.Length);
                return pReadByte;
            }
            catch
            {
                return pReadByte;
            }
            finally
            {
                if (pFileStream != null)
                    pFileStream.Close();
            }
        }

        /// <summary>
        ///单字节转有符号整数
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        public string byteArrayToDecString(byte[] data)
        {
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < data.Length; i++)
            {
                builder.Append((sbyte)data[i] + ",");
            }
            return builder.ToString().Trim();
        }

        private int HISDetailDataExport(string filePath, string fileName)
        {
            try
            {
                DataTable dt = (DataTable)dgvHisSettlRec.DataSource;
                string content = "";
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string flag = "";
                    if (dt.Rows[i]["ValidFlag"].ToString() == "-1")
                    {
                        flag = "1";
                    }
                    else
                    {
                        flag = "0";
                    }
                    content = "\r\n"
                            + dt.Rows[i]["SettlementID"].ToString() + "\t"
                            + dt.Rows[i]["MdtrtID"].ToString() + "\t"
                            + dt.Rows[i]["PersonnelNO"].ToString() + "\t"
                            + dt.Rows[i]["Sumamt"].ToString() + "\t"
                            + dt.Rows[i]["FundPaySumamt"].ToString() + "\t"
                            + dt.Rows[i]["AccountPaySumamt"].ToString() + "\t"
                            + flag
                            + content;
                }
                string finalContent = content.Remove(0, 2);
                writeToTxt(finalContent, filePath, fileName);
                return 0;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return -1;
            }
        }

        private void tsmExport_Click(object sender, EventArgs e)
        {
            txtName = DateTime.Now.ToString("yyyyMMddHHmmssffff");
            txtPath = Global.curEvt.path + "\\Download";
            HISDetailDataExport(txtPath, txtName);
            //System.IO.Compression.ZipFile.CreateFromDirectory(txtPath + "\\" + "2022ceshi", txtPath + "\\" + "111.zip");
        }

        private void tsmCompress_Click(object sender, EventArgs e)
        {
            string path = @"C:\ProgramData\prykNT\prBrowser\bin\service\plugins\INSUNew\DownLoad\111";
            string name = @"1121.zip";
            string finalDirPath = txtPath + "\\" + txtName;
            finalAchPath = finalDirPath + ".zip";
            System.IO.Compression.ZipFile.CreateFromDirectory(finalDirPath, finalAchPath);
            //System.IO.Compression.ZipFile.CreateFromDirectory(path, name);
            //System.IO.Compression.ZipFile.CreateFromDirectory(path, name, 0, true);
        }

        private void tsmZIPToSDec_Click(object sender, EventArgs e)
        {
            byte[] bArray = ReadFileToByte(finalAchPath);
            string str = byteArrayToDecString(bArray);
            Global.writeLog(str);
        }

        private void tsmUploadZIP_Click(object sender, EventArgs e)
        {
            byte[] bArray = ReadFileToByte(finalAchPath);
            string str = "[" + byteArrayToDecString(bArray) + "]";

            JObject joTmp = new JObject();
            joTmp.Add("in", JArray.Parse(str));
            joTmp.Add("filename", txtName + ".zip");
            joTmp.Add("fixmedins_code", Global.inf.hospitalNO);

            JObject joFsUploadIn = new JObject();
            joFsUploadIn.Add("fsUploadIn", joTmp);

            InvokeHelper invoker = new InvokeHelper();
            invoker.invokeCenterService("9101", joFsUploadIn.ToString());
        }

        private void tsm3202_Click(object sender, EventArgs e)
        {
            DataTable dt = (DataTable)dgvSettlSummary.DataSource;
            int i = dgvSettlSummary.CurrentRow.Index;

            dynamic joCheck = new JObject();
            joCheck.file_qury_no = tbTmp.Text;
            joCheck.clr_type = dt.Rows[i]["clr_type"].ToString();
            joCheck.setl_optins = dt.Rows[i]["setl_optins"].ToString();
            joCheck.stmt_begndate = dpST.Value.ToString("yyyy-MM-dd HH:mm:ss");
            joCheck.stmt_enddate = dpED.Value.ToString("yyyy-MM-dd HH:mm:ss");
            joCheck.medfee_sumamt = dt.Rows[i]["medfee_sumamt"].ToString();
            joCheck.fund_pay_sumamt = dt.Rows[i]["fund_pay_sumamt"].ToString();
            joCheck.cash_payamt = dt.Rows[i]["cash_payamt"].ToString();
            joCheck.fixmedins_setl_cnt = dt.Rows[i]["fixmedins_setl_cnt"].ToString();

            JObject joData = new JObject();
            joData.Add("data", joCheck);

            InvokeHelper invoker = new InvokeHelper();
            invoker.invokeCenterService("3202", joData.ToString());
        }

        private void tsmDownload_Click(object sender, EventArgs e)
        {
            JObject joTmp = new JObject();
            joTmp.Add("file_qury_no", tbTmp.Text);
            joTmp.Add("filename", txtName + ".zip");
            joTmp.Add("fixmedins_code", Global.inf.hospitalNO);

            JObject joFsDownloadIn = new JObject();
            joFsDownloadIn.Add("fsDownloadIn", joTmp);

            InvokeHelper invoker = new InvokeHelper();
            jo9102Rtn = invoker.invokeCenterService("9102", JsonHelper.setCenterInpar("9102", joFsDownloadIn).ToString());
        }

        private void tsmUnCompress_Click(object sender, EventArgs e)
        {
            //解压缩
            string zipFilePath = jo9102Rtn["filePath"].ToString();
            string txtFileDir = System.Environment.CurrentDirectory + "\\Download";
            //string txtFilePath = txtFileDir + "\\" + filename.Substring(0, filename.Length - 4);
            string txtFilePath = txtFileDir;
            if (File.Exists(txtFilePath))
            {
                File.Delete(txtFilePath);
            }

            ZipFile.ExtractToDirectory(zipFilePath, txtFileDir);
        }

        private void tsmImport_Click(object sender, EventArgs e)
        {
            GridViewSetter grd = new GridViewSetter();
            grd.SetHeaderTextOfDgvCenterSetlRec(dgvCenterSettlRec);
            string txtFileDir = tbTmp.Text;//E:\GHSF\SCYBDownLoad\result.txt
            string[] lines = System.IO.File.ReadAllLines(txtFileDir);
            Global.writeLog(lines.ToString());

            DataTable dt = new DataTable();
            dt.Columns.Add("sn", typeof(int));
            dt.Columns.Add("psn_no", typeof(string));
            dt.Columns.Add("mdtrt_id", typeof(string));
            dt.Columns.Add("setl_id", typeof(string));
            dt.Columns.Add("msgid", typeof(string));
            dt.Columns.Add("stmt_rslt", typeof(string));
            dt.Columns.Add("refd_setl_flag", typeof(string));
            dt.Columns.Add("memo", typeof(string));
            dt.Columns.Add("medfee_sumamt", typeof(string));
            dt.Columns.Add("fund_pay_sumamt", typeof(string));
            dt.Columns.Add("acct_pay", typeof(string));

            //foreach (string line in lines)
            for (int i = 0; i < lines.Length; i++)
            {
                string[] strs = (lines[i] + "\t").Split('\t');
                DataRow dr = dt.NewRow();
                //Global.inf.writeLog(lines[i].ToString());
                //Global.inf.writeLog(strs.Length.ToString());

                dr["sn"] = i;
                dr["psn_no"] = strs[0];
                dr["mdtrt_id"] = strs[1];
                dr["setl_id"] = strs[2];
                dr["msgid"] = strs[3];
                dr["stmt_rslt"] = strs[4];
                dr["refd_setl_flag"] = strs[5];
                dr["memo"] = strs[6];
                dr["medfee_sumamt"] = strs[7];
                dr["fund_pay_sumamt"] = strs[8];
                dr["acct_pay"] = strs[9];
                //dr["Field2"] = strs[2];

                dt.Rows.Add(dr);
            }
            dgvCenterSettlRec.DataSource = dt;
        }

        

        
        private int checkDetail(out string fileName, out string outParam)
        {
            fileName = "";
            try
            {
                DataTable dt = (DataTable)dgvSettlSummary.DataSource;
                int i = dgvSettlSummary.CurrentRow.Index;
                dynamic joCheck = new JObject();
                joCheck.startdate = dpST.Text;
                joCheck.enddate = dpED.Text;
                joCheck.clrtype = dt.Rows[i]["clr_type"].ToString();
                if (cbxOtherPlcFlag.SelectedIndex == 1)
                {
                    joCheck.ydfalg = "1";
                }
                else
                {
                    joCheck.ydfalg = "";
                }
                


                JObject joData = new JObject();
                joData.Add("data", joCheck);
                InvokeHelper invoker = new InvokeHelper();
                JObject jo3261Rtn = invoker.invokeCenterService("3261", joData);
                if (JsonHelper.parseCenterRtnValue(jo3261Rtn, out outParam) != 0)
                {
                    return -1;
                }
                else
                {
                    outParam = "明细对账成功";
                    fileName = JsonHelper.getDestValue(jo3261Rtn, "output.ObjectKey");
                    return 0;
                }
            }
            catch (Exception ex)
            {
                outParam = "checkDetail:" + ex.Message;
                return -1;
            }

        }

        private int downloadTxt( string fileName, out string outParam)
        {
            outParam = "";
            try
            {
                string newfileName = fileName.Replace('/', '\\');
                Global.writeLog(newfileName);
                Global.writeLog(newfileName.LastIndexOf("\\").ToString());
                //下载3262
                JObject joTmp = new JObject();
                joTmp.Add("filename", fileName);
                JObject joData = new JObject();
                joData.Add("data", joTmp);

                InvokeHelper invoker = new InvokeHelper();
                JObject joRtn = invoker.DownloadCenterFile(newfileName, JsonHelper.setCenterInpar("3262", joData));
                outParam = joRtn.ToString();
                return 0;
            }
            catch (Exception ex)
            {
                outParam = ex.Message;
                return -1;
            }
        }
        
        private int importToDgvCenterSetlRec(string fileName, out string outParam)
        {
            outParam = "";
            try
            {
                //导入文件
                GridViewSetter grd = new GridViewSetter();
                grd.SetHeaderTextOfDgvCenterSetlRec(dgvCenterSettlRec);
                //txtFileDir = txtFileDir;//E:\GHSF\SCYBDownLoad\result.txt
                string[] lines = System.IO.File.ReadAllLines(fileName, System.Text.Encoding.Default);

                DataTable dt = new DataTable();
                dt.Columns.Add("sn", typeof(string));      //序号
                dt.Columns.Add("P1", typeof(string));      //结算ID
                dt.Columns.Add("P2", typeof(string));      //原结算ID
                dt.Columns.Add("P3", typeof(string));      //就诊ID
                dt.Columns.Add("P4", typeof(string));      //人员编号
                dt.Columns.Add("P5", typeof(string));      //人员姓名
                dt.Columns.Add("P6", typeof(string));      //证件号码
                dt.Columns.Add("P7", typeof(string));      //支付地点类别
                dt.Columns.Add("P8", typeof(string));      //定点医药机构编号
                dt.Columns.Add("P9", typeof(string));      //定点医药机构名称
                dt.Columns.Add("P10", typeof(string));      //结算时间
                dt.Columns.Add("P11", typeof(string));      //医疗类别
                dt.Columns.Add("P12", typeof(string));      //结算类别
                dt.Columns.Add("P13", typeof(string));      //清算类别
                dt.Columns.Add("P14", typeof(string));      //清算方式
                dt.Columns.Add("P15", typeof(string));      //个人结算方式
                dt.Columns.Add("P16", typeof(string));      //医疗费总额
                dt.Columns.Add("P17", typeof(string));      //全自费金额
                dt.Columns.Add("P18", typeof(string));      //超限价自费费用
                dt.Columns.Add("P19", typeof(string));      //先行自付金额
                dt.Columns.Add("P20", typeof(string));      //符合范围金额
                dt.Columns.Add("P21", typeof(string));      //起付标准
                dt.Columns.Add("P22", typeof(string));      //本次起付线
                dt.Columns.Add("P23", typeof(string));      //实际支付起付线
                dt.Columns.Add("P24", typeof(string));      //统筹基金支出
                dt.Columns.Add("P25", typeof(string));      //基本医疗统筹支付比例
                dt.Columns.Add("P26", typeof(string));      //医保认可费用总额
                dt.Columns.Add("P27", typeof(string));      //公务员医疗补助资金支出
                dt.Columns.Add("P28", typeof(string));      //补充医疗保险基金支出
                dt.Columns.Add("P29", typeof(string));      //大病补充医疗保险基金支出
                dt.Columns.Add("P30", typeof(string));      //大额医疗补助基金支出
                dt.Columns.Add("P31", typeof(string));      //伤残人员医疗保障基金支出
                dt.Columns.Add("P32", typeof(string));      //医疗救助基金支出
                dt.Columns.Add("P33", typeof(string));      //其它基金支付
                dt.Columns.Add("P34", typeof(string));      //基金支付总额
                dt.Columns.Add("P35", typeof(string));      //个人支付金额
                dt.Columns.Add("P36", typeof(string));      //个人账户支出
                dt.Columns.Add("P37", typeof(string));      //现金支付金额
                dt.Columns.Add("P38", typeof(string));      //自费中医院负担部分
                dt.Columns.Add("P39", typeof(string));      //余额
                dt.Columns.Add("P40", typeof(string));      //账户共济支付金额
                dt.Columns.Add("P41", typeof(string));      //退费结算标志
                dt.Columns.Add("P42", typeof(string));      //计算住院次数标志
                dt.Columns.Add("P43", typeof(string));      //结算现金支付方式
                dt.Columns.Add("P44", typeof(string));      //有效标志
                dt.Columns.Add("P45", typeof(string));      //医疗机构对账标志（本地有，异地无）
                dt.Columns.Add("P46", typeof(string));      //按病种结算支付金额（本地有，异地无）
                dt.Columns.Add("P47", typeof(string));      //除外项目基金支付金额（本地有，异地无）

                //foreach (string line in lines)
                for (int i = 0; i < lines.Length; i++)
                {
                    string[] strs = (lines[i] + "\t").Split('\t');
                    DataRow dr = dt.NewRow();
                    //Global.inf.writeLog(lines[i].ToString());
                    //Global.inf.writeLog(strs.Length.ToString());
                    dr["sn"] = i + 1;
                    dr["P1"] = strs[0];   //结算ID
                    dr["P2"] = strs[1];   //原结算ID
                    dr["P3"] = strs[2];   //就诊ID
                    dr["P4"] = strs[3];   //人员编号
                    dr["P5"] = strs[4];   //人员姓名
                    dr["P6"] = strs[5];   //证件号码
                    dr["P7"] = strs[6];   //支付地点类别
                    dr["P8"] = strs[7];   //定点医药机构编号
                    dr["P9"] = strs[8];   //定点医药机构名称
                    dr["P10"] = strs[9];   //结算时间
                    dr["P11"] = strs[10];   //医疗类别
                    dr["P12"] = strs[11];   //结算类别
                    dr["P13"] = strs[12];   //清算类别
                    dr["P14"] = strs[13];   //清算方式
                    dr["P15"] = strs[14];   //个人结算方式
                    dr["P16"] = strs[15];   //医疗费总额
                    dr["P17"] = strs[16];   //全自费金额
                    dr["P18"] = strs[17];   //超限价自费费用
                    dr["P19"] = strs[18];   //先行自付金额
                    dr["P20"] = strs[19];   //符合范围金额
                    dr["P21"] = strs[20];   //起付标准
                    dr["P22"] = strs[21];   //本次起付线
                    dr["P23"] = strs[22];   //实际支付起付线
                    dr["P24"] = strs[23];   //统筹基金支出
                    dr["P25"] = strs[24];   //基本医疗统筹支付比例
                    dr["P26"] = strs[25];   //医保认可费用总额
                    dr["P27"] = strs[26];   //公务员医疗补助资金支出
                    dr["P28"] = strs[27];   //补充医疗保险基金支出
                    dr["P29"] = strs[28];   //大病补充医疗保险基金支出
                    dr["P30"] = strs[29];   //大额医疗补助基金支出
                    dr["P31"] = strs[30];   //伤残人员医疗保障基金支出
                    dr["P32"] = strs[31];   //医疗救助基金支出
                    dr["P33"] = strs[32];   //其它基金支付
                    dr["P34"] = strs[33];   //基金支付总额
                    dr["P35"] = strs[34];   //个人支付金额
                    dr["P36"] = strs[35];   //个人账户支出
                    dr["P37"] = strs[36];   //现金支付金额
                    dr["P38"] = strs[37];   //自费中医院负担部分
                    dr["P39"] = strs[38];   //余额
                    dr["P40"] = strs[39];   //账户共济支付金额
                    dr["P41"] = strs[40];   //退费结算标志
                    dr["P42"] = strs[41];   //计算住院次数标志
                    dr["P43"] = strs[42];   //结算现金支付方式
                    dr["P44"] = strs[43];   //有效标志
                    dr["P45"] = strs[44];   //医疗机构对账标志（本地有，异地无）
                    dr["P46"] = strs[45];   //按病种结算支付金额（本地有，异地无）
                    dr["P47"] = strs[46];   //除外项目基金支付金额（本地有，异地无）

                    dt.Rows.Add(dr);
                }
                dgvCenterSettlRec.DataSource = dt;

                return 0;
            }
            catch (Exception ex)
            {
                outParam = "importToDgvCenterSetlRec:" + ex.Message;
                return -1;
            }
        }

        private int CheckDetail_Single(out string outParam)
        {
            outParam = "";

            try
            {
;
                string file_query_no = outParam;
                string fileName = "";
                //3202明细对账  输出查询号和文件名
                if (checkDetail(out fileName,out outParam) != 0)
                {
                    return -1;
                }
                Global.writeLog("checkDetail:" + outParam + "///" + fileName);

                //下载3262
                if (downloadTxt(fileName, out outParam) != 0)
                {
                    return -1;
                }
                else
                {
                    fileName = JsonHelper.getDestValue(JObject.Parse(outParam), "filePath");
                }
                //导入DGV
                if (importToDgvCenterSetlRec(fileName,  out outParam) != 0)
                {
                    return -1;
                }
                Global.writeLog("importToDgvCenterSetlRec:" + outParam);
                return 0;
            }
            catch (Exception ex)
            {
                outParam = "CheckDetail_Single:" + ex.Message;
                return -1;
            }

        }

        private void dgvRowStateChanged(object sender, DataGridViewRowStateChangedEventArgs e)
        {
            DataGridView dgv = (DataGridView)sender;
            dgv.RowHeadersWidth = 60;
            if (dgv.Rows.Count > 1)
                e.Row.HeaderCell.Value = string.Format("{0}", e.Row.Index + 1);
        }

        private void dgvSettlSummary_RowStateChanged(object sender, DataGridViewRowStateChangedEventArgs e)
        {
            if (dgvSettlSummary.Rows.Count > 1)
                e.Row.HeaderCell.Value = string.Format("{0}", e.Row.Index + 1);
        }

        private void dgvHisSettlRec_RowStateChanged(object sender, DataGridViewRowStateChangedEventArgs e)
        {
            if (dgvHisSettlRec.Rows.Count > 1)
                e.Row.HeaderCell.Value = string.Format("{0}", e.Row.Index + 1);
        }
        private int compareDataGridView(string value, string colName, Sunny.UI.UIDataGridView dgv)
        {
            try
            {
                for (int i = 0; i < dgv.RowCount; i++)
                {
                    if (dgv.Rows[i].Cells[colName].Value.ToString() == value)
                    {
                        return 0;
                    }
                }
                return -1;
            }
            catch (Exception ex)
            {
                MessageBox.Show("compareDataGridView" + ex.Message);
                return -1;
            }
        }
        private void tsmAICheck_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < dgvHisSettlRec.RowCount; i++)
            {
                string value = dgvHisSettlRec.Rows[i].Cells["SettlementID"].Value.ToString();
                string colName = "P1";
                if (compareDataGridView(value, colName, dgvCenterSettlRec) != 0)
                {
                    dgvHisSettlRec.Rows[i].DefaultCellStyle.BackColor = Color.Red;
                    rtbCheckDetailLog.AppendText("HIS结算ID:" + value + "在中心明细中未找到数据！" + "\r\n");
                }
            }

            for (int i = 0; i < dgvCenterSettlRec.RowCount; i++)
            {
                string value = dgvCenterSettlRec.Rows[i].Cells["P1"].Value.ToString();
                string colName = "SettlementID";
                if (compareDataGridView(value, colName, dgvHisSettlRec) != 0)
                {
                    dgvCenterSettlRec.Rows[i].DefaultCellStyle.BackColor = Color.Red;
                    rtbCheckDetailLog.AppendText("中心结算ID:" + value + "在HIS明细中未找到数据！" + "\r\n");
                }
            }
        }

        private void tsmCheckDetail_Batch_Click(object sender, EventArgs e)
        {

        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            int i = dgvHisSettlRec.CurrentRow.Index;
            DataTable dt = (DataTable)dgvHisSettlRec.DataSource;
            MessageBox.Show(dt.Rows[i]["AccountPaySumamt"].ToString());
        }

        private void btnAddOneDay_Click(object sender, EventArgs e)
        {
            dpST.Value = dpST.Value.AddDays(1);
            dpED.Value = dpED.Value.AddDays(1);
        }

        private void btnReduceOndDay_Click(object sender, EventArgs e)
        {
            dpST.Value = dpST.Value.AddDays(-1);
            dpED.Value = dpED.Value.AddDays(-1);
        }



        



        private ArrayList getIndexArray(String inputStr, String findStr)
        {
            ArrayList list = new ArrayList();
            int start = 0;

            while (start < inputStr.Length)
            {
                int index = inputStr.IndexOf(findStr, start);

                if (index >= 0)

                {
                    list.Add(index);
                    start = index + findStr.Length;
                }
                else
                {
                    break;
                }
            }

            return list;
        }

        

        private void tsmHandCheck_Click(object sender, EventArgs e)
        {
            JObject joData = JObject.Parse(rtbCheckDetailLog.Text);
            InvokeHelper invoker = new InvokeHelper();
            JObject joRtn = invoker.invokeCenterService("3201", joData.ToString());

        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Btn_Query_Click(object sender, EventArgs e)
        {
            //GridViewSetter grdSetter = new GridViewSetter();
            //grdSetter.SetHeaderTextOfCheck(dgvSettlSummary);
            DataTable dtInteface = (DataTable)cbxInterface.DataSource;
            int i = cbxInterface.SelectedIndex;
            //乘以单据类型后，IRIS会返回整数，关键不知道SQL里咋转换为浮点数
            //string sqlStr = "SELECT SUM(BillType*Sumamt) AS medfee_sumamt,count(*) AS fixmedins_setl_cnt,SUM(BillType*PersonCashPay) AS cash_payamt, ";
            //sqlStr = sqlStr + " SUM(BillType*AccountPaySumamt) AS acct_pay,SUM(BillType*FundPaySumamt) AS fund_pay_sumamt ";

            string sqlStr = "SELECT SUM(BillType*Sumamt) AS medfee_sumamt,count(*) AS fixmedins_setl_cnt,SUM(BillType*PersonCashPay) AS cash_payamt,  ";
            sqlStr = sqlStr + " SUM(billType*AccountPaySumamt) AS acct_pay,SUM(BillType*FundPaySumamt) AS fund_pay_sumamt ";
            //sqlStr = sqlStr + " Interface_dr,clearingWay AS clr_way,clearingType AS clr_type ";
            string conditionStr = " Group By";
            if (cbgGroupSet.GetItemCheckState(0))
            {
                sqlStr = sqlStr + ",Interface_Dr";
                conditionStr = conditionStr + " Interface_Dr,";
                //dgvSettlSummary.Columns.Remove("Interface_Dr");
            }
            if (cbgGroupSet.GetItemCheckState(1))
            {
                sqlStr = sqlStr + ",InsuranceType as insutype";
                conditionStr = conditionStr + " InsuranceType,";
            }
            if (cbgGroupSet.GetItemCheckState(2))
            {
                sqlStr = sqlStr + ",ClearingType as clr_type";
                conditionStr = conditionStr + " ClearingType,";
            }
            if (cbgGroupSet.GetItemCheckState(3))
            {
                sqlStr = sqlStr + ",ClearingOrgan as setl_optins";
                conditionStr = conditionStr + " ClearingOrgan,";
            }
            if (cbgGroupSet.GetItemCheckState(4))
            {
                sqlStr = sqlStr + ",BillType";
                conditionStr = conditionStr + " BillType,";
            }

            sqlStr = sqlStr + " FROM BS_MedInsuSettlement WHERE Hospital_Dr=" + dtInteface.Rows[i]["HospitalDr"].ToString();
            sqlStr = sqlStr + " and OccurTime>'" + dpST.Text + "'";
            sqlStr = sqlStr + " and OccurTime<'" + dpED.Text + "'";

            if ((cbxInterface.Text != "") && cbgGroupSet.GetItemCheckState(0))
            {
                sqlStr = sqlStr + " and Interface_Dr =" + dtInteface.Rows[i]["ID"].ToString();
            }

            if (cbxInsuType.Text != "")
            {
                sqlStr = sqlStr + " and InsuranceType ='" + cbxInsuType.SelectedValue + "'";
            }

            if (cbxClrType.Text != "")
            {
                sqlStr = sqlStr + " and ClearingType ='" + cbxClrType.SelectedValue + "'";
            }

            if (tbSettlOption.Text != "")
            {
                sqlStr = sqlStr + " and ClearingOrgan ='" + tbSettlOption.Text + "'";
            }

            //ValidFlag=1 and BillType=1 表示正常结算记录   ValidFlag=0 and BillType=-1 表示退费记录  ValidFlag=0表示无效记录 
            if (cbxValid.SelectedIndex != 0)
            {
                if (cbxValid.SelectedIndex == 1)
                    sqlStr = sqlStr + " and ValidFlag =1 and BillType=1 ";
                else
                    sqlStr = sqlStr + " and ValidFlag =0 and BillType=-1";
            }

            sqlStr = sqlStr + " and ReversalFlag <> 1 ";

            if (cbxOtherPlcFlag.SelectedIndex == 1)
                sqlStr = sqlStr + " and (InsuranceAreaCode<>'239900' and SUBSTRING(InsuranceAreaCode,1,4)<>'2301' and SUBSTRING(InsuranceAreaCode,1,4)<>'2331')";
            else if (cbxOtherPlcFlag.SelectedIndex == 0)
                sqlStr = sqlStr + " and (InsuranceAreaCode='239900' or SUBSTRING(InsuranceAreaCode,1,4) in ('2301','2331'))";
            //铁路医保参保地为233100 这里对账的时候需要包含进去1

            //conditionStr = conditionStr.Substring(0,conditionStr.Length -1 );
            conditionStr = conditionStr.Remove(conditionStr.Length - 1, 1);

            sqlStr = sqlStr + conditionStr;
            JObject joSqlstr = new JObject();

            joSqlstr.Add("sqlStr", sqlStr);
            JArray jaParam = new JArray();
            jaParam.Add(joSqlstr);
            JObject joSettlQuery = new JObject();
            joSettlQuery.Add("params", jaParam);
            joSettlQuery.Add("code", "09010061");
            InvokeHelper invoker = new InvokeHelper();
            JObject joRtn = invoker.invokeInsuService(joSettlQuery.ToString(), "查询汇总结算信息");

            DataTable dt = (DataTable)joRtn["result"]["data"].ToObject(typeof(DataTable));
            dgvSettlSummary.DataSource = dt;

            //初始化HIS结算明细View数据
            dgvHisSettlRec.DataSource = null;
        }

       
        private void dgvSettlSummary_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            string error;
            if (queryHisSettlementInfo(out error) != 0)
            {
                MessageBox.Show(error);
            }
        }

        private void btClose_2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btQueryMonthSettlData_Click(object sender, EventArgs e)
        {
            grdSetter.SetHeaderTextOfCenterMonthSettlData(dgvCenterMonthSettlData);
            dynamic joTmp = new JObject();
            joTmp.begndate = dpMonth.Value.ToString("yyyy-MM-dd");          //对账结束日期

            JObject joData = new JObject();
            joData.Add("data", joTmp);

            //上传给中心
            InvokeHelper invoker = new InvokeHelper();
            JObject joRtn = invoker.invokeCenterService("5261", joData);
            string error;
            if (JsonHelper.parseCenterRtnValue(joRtn, out error) != 0)
            {
                MessageBox.Show(error);
            }
            else
            {
                JArray jaData = JArray.Parse(JsonHelper.getDestValue(joRtn, "output.data"));
                DataTable dt = (DataTable)jaData.ToObject(typeof(DataTable));
                dgvCenterMonthSettlData.DataSource = dt;
            }
        }

        private void uiSymbolButton2_Click(object sender, EventArgs e)
        {
            dpMonth.Value = dpMonth.Value.AddMonths(1);
        }

        private void uiSymbolButton1_Click(object sender, EventArgs e)
        {
            dpMonth.Value = dpMonth.Value.AddMonths(-1);
        }

        private void cbxInterface_2_SelectedIndexChanged(object sender, EventArgs e)
        {
            DataTable dtInteface = (DataTable)cbxInterface_2.DataSource;
            int i = cbxInterface_2.SelectedIndex;
            Global.inf.hospitalNO = dtInteface.Rows[i]["HospitalNO"].ToString();
            Global.inf.hospitalName = dtInteface.Rows[i]["HospitalName"].ToString();
            Global.inf.centerURL = dtInteface.Rows[i]["CenterURL"].ToString();
            Global.inf.areaCode = dtInteface.Rows[i]["AreaCode"].ToString();
            //Global.inf.operatorType = "3";
            Global.inf.version = "v1.0";
            Global.inf.recivedSystem = "SY";
            Global.inf.interfaceDr = int.Parse(dtInteface.Rows[i]["ID"].ToString());
        }
    }
}
