﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PTMedicalInsurance.Common;
using PTMedicalInsurance.Helper;
using PTMedicalInsurance.Variables;


namespace PTMedicalInsurance.Forms
{
    public partial class OutpatientRegistration : Form
    {
        public OutpatientRegistration()
        {
            InitializeComponent();
            /*
                string sqlCondition = " and Interface_ID = '" + GlobalVariables.InterfaceID + "'";
                string sqlStr = "select sNO AS Code,Name FROM CloudMedicalInsurancePlatform_Tables.Dictionary where Type = 'insutype'" + sqlCondition;
                //SetDBLKCombox(ref dblkcbxInsuranceType, sqlStr);

                string sqlStr2 = "select Code,Name FROM CloudMedicalInsurancePlatform_Tables.Dictionary where Type='insutype' and Interface_Dr = '7'and Hosp_Dr ='63'";
                SetDBLKCombox(ref dblkcbxInsuranceType, sqlStr2);

                sqlStr = "select Code,SectionName AS Name FROM CloudMedicalInsurancePlatform_Tables.Diagnose where Type='Diagnose'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxDisease, sqlStr2);

                sqlStr = "select sNO AS Code,Name FROM CloudMedicalInsurancePlatform_Tables.Dictionary where Type = 'psn_setlway'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxSettelmentWay, sqlStr);

                sqlStr = "select sNO AS Code,Name FROM CloudMedicalInsurancePlatform_Tables.Dictionary where Type = 'MED_TYPE'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxMedicalType, sqlStr);

                sqlStr = "select Code,Name FROM CloudMedicalInsurancePlatform_Tables.Diagnose where Type='Operation'" + sqlCondition;
                SetDBLKCombox(ref dblkcbxOperation, sqlStr);
            */
            //字典类，目录类查询都用区域医保对应的接口目录DR
            string sqlCondition = " and A.Interface_Dr = '" + Global.inf.InsuRegionInterfaceDr.ToString() + "'";
            //险种
            string sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'insutype'" + sqlCondition;
            SetDBLKCombox(ref dblkcbxInsuranceType, sqlStr);
            
            //结算方式
            sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'psn_setlway'" + sqlCondition;
            SetDBLKCombox(ref dblkcbxSettelmentWay, sqlStr);
            //医疗类别
            sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'med_type'" + sqlCondition;
            SetDBLKCombox(ref dblkcbxMedicalType, sqlStr);
            //医疗类别
            sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'med_type'" + sqlCondition;
            SetDBLKCombox(ref dblkcbxMedicalType, sqlStr);
            //哈尔滨增加商业保险
            sqlStr = "SELECT B.Code,B.Descripts AS Name FROM HB_Dictionary A JOIN HB_DictionaryDataDetail B ON A.ID = B.HBDictionary_Dr  WHERE A.InsuCode = 'ipt_psn_sp_flag_type'" + sqlCondition;
            SetDBLKCombox(ref dblckCommercialInsurance, sqlStr);

            cbxAccountPay.Checked = true;
            personAccountUsedFlag = "1";
            Global.pat.isCommercialInsurance = false;
        }

        private DataTable dtDisease;
        private DataTable dtDiseaseType;
        private DataTable dtInsuranceType;
        private DataTable dtMedicalType;
        private DataTable dtOperation;
        private DataTable dtSettelmentType;
        //险种
        public string  insuType { get; set; }
        public string insuTypeName { get; set; }
        //医疗类别
        public string med_type { get; set; }
        public string med_type_name { get; set; }
        //诊断
        public string diseCodg { get; set; }

        public string diseName{ get; set; }
        //手术
        public string oprn_oprt_code { get; set; }
        public string oprn_oprt_name{ get; set; }
        //病种
        public string dise_type_code { get; set; }

        public string dise_type_name { get; set; }
        //结算方式
        public string psn_setlway { get; set; }

        public string psn_setlway_name { get; set; }

        public DataTable DtDiagnose { get; set; }

        public string personAccountUsedFlag = "0";


        private DataTable GetDBLKComboxTable(string sqlStr)
        {
            InvokeHelper invoker = new InvokeHelper();
            dynamic joInparm = new JObject();
            
            dynamic joTmp = new JObject();
            joTmp.sqlStr = sqlStr;
            JArray jaParams = new JArray();
            jaParams.Add(joTmp);
            joInparm.Add("params", JArray.FromObject(jaParams));
            joInparm.code = "09010014";
            string inParam = joInparm.ToString();
            JObject joRtn = invoker.invokeInsuService(inParam,"获取下拉框消息");
            //dynamic jsonRtn = JsonConvert.DeserializeObject(strRtn);
            DataTable dt = (DataTable)joRtn["result"].ToObject(typeof(DataTable));
            //dt.Columns[0].ColumnName = "编码";
            //dt.Columns[1].ColumnName = "名称";
            //dt.Columns[2].ColumnName = "拼音查找码";
            return dt;
        }
        private void SetDBLKCombox(ref  PTControl.DBLookupCombox dblcbx, string sqlStr)
        {
            dblcbx.sDisplayField = "Code,Name,SearchCode";
            dblcbx.sDisplayMember = "名称";
            dblcbx.sKeyWords = "Code,SearchCode";
            dblcbx.DataSource = GetDBLKComboxTable(sqlStr);
            dblcbx.RowFilterVisible = true;
            dblcbx.TextBox.Width = 400;
            dblcbx.DataGridView.Width = 400;
            dblcbx.DataGridView.Columns[0].Name = "编码";
            dblcbx.DataGridView.Columns[1].Name = "名称";
            dblcbx.DataGridView.Columns[2].Name = "查找码";
            dblcbx.DataGridView.Columns[0].Width = 100;
            dblcbx.DataGridView.Columns[1].Width = 200;
        }
        private void OutpatientRegistration_Load(object sender, EventArgs e)
        {
            dgvDiagnose.AutoGenerateColumns = false;
            dgvDiagnose.DataSource = DtDiagnose;
            //DtDiagnose.AcceptChanges();
            dgvDiagnose.ReadOnly = true;
        }


        private void button1_Click_1(object sender, EventArgs e)
        {
            if (cbxCommercialInsurance.Checked)
            {
                Global.pat.isCommercialInsurance = true;
            }
            this.DialogResult = DialogResult.OK;
        }

        private void dblkcbxInsuranceType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;
            insuType = dataRow["Code"].ToString().Trim();
            insuTypeName = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxMedicalType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            med_type = dataRow["Code"].ToString().Trim();
            med_type_name = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxDisease_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            diseCodg = dataRow["Code"].ToString().Trim();
            diseName = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxOperation_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            oprn_oprt_code = dataRow["Code"].ToString().Trim();
            oprn_oprt_name = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxSettelmentWay_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            psn_setlway = dataRow["Code"].ToString().Trim();
            psn_setlway_name = dataRow["Name"].ToString().Trim();
        }

        private void dblkcbxDiseaseType_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            dise_type_code = dataRow["Code"].ToString().Trim();
            dise_type_name = dataRow["Name"].ToString().Trim();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        private void cbxAccountPay_ValueChanged(object sender, bool value)
        {
            if (cbxAccountPay.Checked)
            {
                personAccountUsedFlag = "1";
            }
            else
            {
                personAccountUsedFlag = "0";
            }
        }

        private void cbxCommercialInsurance_ValueChanged(object sender, bool value)
        {
            if (cbxCommercialInsurance.Checked)
            {
                dblckCommercialInsurance.Enabled = true;
            }
            else
            {
                dblckCommercialInsurance.Enabled = false;
            }
        }

        private void dblckCommercialInsurance_AfterSelector(object sender, PTControl.AfterSelectorEventArgs e)
        {
            DataGridViewRow row = e.Value as DataGridViewRow;
            DataRowView dataRow = row.DataBoundItem as DataRowView;

            Global.pat.specAttribute = dataRow["Code"].ToString().Trim();
        }
    }
}
