﻿using PTMedicalInsurance.Variables;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PTMedicalInsurance.Helper
{
    class HisCallFace
    {
        //人脸验证
        [DllImport("HisCallFace.dll", EntryPoint = "zjHisFunCall", CharSet = CharSet.Ansi, ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        static extern int zjHisFunCall(StringBuilder inputJson, StringBuilder outJson);
        //考勤
        [DllImport("HisCallFace.dll", EntryPoint = "HisCallAtten", CharSet = CharSet.Ansi, ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        static extern int HisCallAtten(string hisMsg,  ref byte outMsg);

        public int zjHisFunCall( string inputJson, out string outJson)
        {
            outJson = "";
            try
            {
                StringBuilder sbIn= new StringBuilder(inputJson);
                StringBuilder sbOut = new StringBuilder(50*1024);

                int iRtn = zjHisFunCall(sbIn,sbOut);
                outJson = sbOut.ToString();
                return iRtn;
            }
            catch (Exception ex)
            {
                outJson = "zjHisFunCall 异常:" + ex.Message;
                return -1;
            }
            finally
            {
                Global.writeLog("人脸验证", inputJson, outJson);
            }
        }

        //public int HisCallAtten(string hisMsg, out string outMsg)
        //{
        //    outMsg = "";
        //    try
        //    {
        //        StringBuilder sbIn = new StringBuilder(hisMsg);
        //        StringBuilder sbOut = new StringBuilder(50*1024);

        //        int iRtn = HisCallAtten(sbIn, sbOut);
        //        outMsg = sbOut.ToString();
        //        return iRtn;
        //    }
        //    catch (Exception ex)
        //    {
        //        outMsg = "HisCallAtten 异常:" + ex.Message;
        //        return -1;
        //    }
        //    finally
        //    {
        //        Global.writeLog("医师考勤", hisMsg, outMsg);
        //    }
        //}

        public int HisCallAtten(string hisMsg, out string outMsg)
        {
            outMsg = "";
            try
            {
                Byte[] bPara = new Byte[10*1024];
                int i = HisCallAtten(hisMsg, ref bPara[0]);
                outMsg = System.Text.Encoding.Default.GetString(bPara, 0, bPara.Length);
                return i;
            }
            catch (Exception ex)
            {
                Global.writeLog_encrypt("签名异常" + ex.Message);
                return -1;
            }
        }
    }
}
